SystemOrganization addCategory: #'PLP-TP3-Pokemon'!

Object subclass: #Pokemon
	instanceVariableNames: 'nombre nivel energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
ataqueBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:29'!
defensaBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 23:27'!
energiaBase
	self subclassResponsibility.! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:41'!
nuevaEspecie: nombreEspecie conTipo: nombreTipo energiaBase: eb ataqueBase: ab defensaBase: db
	"Agrega dinamicamente una subclase con el nombre de especie asignado  y genera sus metodos con los parmetros tal como son indicados. Para esto  se compilan los metodos para que retornen los  valores sobreescribiendo el shouldBeImplemented del super"

	| newSpecies |
	newSpecies := Pokemon subclass: nombreEspecie asSymbol.
	newSpecies class compile: 'ataqueBase ^' , ab asString.
	newSpecies class compile: 'defensaBase ^' , db asString.
	newSpecies class compile: 'energiaBase ^' , eb asString.
	newSpecies class compile: 'tipo ^Tipo new: ' , nombreTipo name.	"Es necesario el name para que funcione"
	newSpecies class compile: 'new: nombrePokemon ^self new initialize: nombrePokemon '.	"No queremos que se pueda crear una instancia de Pokemon, asi que preferimos compilar el new para cada subclase"
	^ newSpecies! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:30'!
tipo
	self subclassResponsibility.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
atacarA: oponente conPoder: poder deTipo: unTipo

	|multiplier damage|
	
	self hasFainted ifTrue: [Error signal: 'Pokemon has fainted, it cannot attack until it is cured'].
	oponente hasFainted ifTrue: [Error signal: 'Opponent has fainted, it cannot be attacked until it is cured'].
	
	multiplier := self getMultiplier: unTipo  attacking: oponente tipo. 
	damage := self calculateDamage: poder withMultiplier: multiplier onOpponent: oponente.
	
	oponente herir: damage.
	
	oponente hasFainted ifTrue: [self subirNivel]! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
ataque
	^ ((self class ataqueBase * 2 + 94) * (nivel / 100) + 5) rounded! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:29'!
calculateDamage: poder withMultiplier: multiplier onOpponent: oponente.

	^(((((2 *(self nivel/5)+2)*self ataque*(poder/oponente defensa))/50)+2)*multiplier) rounded! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
curar: valor
	energia := energia + valor min: self energiaTotal! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:29'!
defensa
	^ ((self class defensaBase * 2 + 94) * (nivel / 100) + 5) rounded ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
energia
	^ energia! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
energiaTotal
	^ ((self class energiaBase * 2 + 94) * (nivel / 100) + 10 + nivel) rounded! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
getMultiplier: attackingType attacking: opponentType
	^ (attackingType = self tipo
		ifTrue: [ 1.5 ]
		ifFalse: [ 1 ]) * (attackingType efectividadContra: opponentType nombre)! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
hasFainted
	
	^energia = 0.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:28'!
herir: valor
	energia := energia - valor max: 0! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
initialize: nombrePokemon
	nombre := nombrePokemon.
	nivel := 1.
	energia := self energiaTotal! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
nivel
	^nivel! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
nombre
	^nombre! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:27'!
subirNivel
	nivel := 100 min: nivel + 1! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:30'!
tipo
	^self class tipo! !

Object subclass: #Tipo
	instanceVariableNames: 'nombre efectividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:57'!
cargarTiposIniciales
	| fuego agua normal planta fantasma |
	fuego := Tipo getInstance: 'fuego'.
	agua := Tipo getInstance: 'agua'.
	normal := Tipo getInstance: 'normal'.
	planta := Tipo getInstance: 'planta'.
	fantasma := Tipo getInstance: 'fantasma'.
	fuego
		efectividad: 1 / 2 contra: 'fuego';
		efectividad: 1 / 2 contra: 'agua';
		efectividad: 2 contra: 'planta'.
	agua
		efectividad: 2 contra: 'fuego';
		efectividad: 1 / 2 contra: 'agua';
		efectividad: 1 / 2 contra: 'planta'.
	normal efectividad: 0 contra: 'fantasma'.
	planta
		efectividad: 1 / 2 contra: 'fuego';
		efectividad: 2 contra: 'agua';
		efectividad: 1 / 2 contra: 'planta'.
	fantasma
		efectividad: 0 contra: 'normal';
		efectividad: 2 contra: 'fantasma'! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:05'!
existeTipo: nombreTipo 
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [:v | ^ true ]
		ifAbsent: [:v | ^ false ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:04'!
getInstance: nombreTipo
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [ :val | ^ val ]
		ifAbsent: [ :nombre | ^ Tipo new initializeOnNombre: nombre ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/21/2012 14:22'!
iterateInstancesSearchFor: nombreTipo andDo: aBlock ifAbsent: anotherBlock
   "Recorre todas las instancias de la clase, para aquellas que coincide con el  tipo asignado ejecuta un bloque, esto se usa para no repetir cdigo, ya que existeTipo y getTipo hacen lo mismo, solo que devuelven diferentes resultados cuando encuentran o no al tipo buscado"

	Tipo
		allInstancesDo: [ :each | 
			each nombre = nombreTipo
				ifTrue: [ ^ aBlock value: each ] ].
	^ anotherBlock value: nombreTipo! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:21'!
new: nombreTipo

	^Tipo getInstance: nombreTipo.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:20'!
= aType
	^nombre = aType nombre.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:23'!
checkValueIsValid: valor
	^ #(0 1 2 0.5) includes: valor! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:44'!
efectividad: valor contra: nombreTipo
	((Tipo existeTipo: nombreTipo) and: (self checkValueIsValid: valor))
		ifTrue: [ efectividades at: nombreTipo put: valor ]! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:46'!
efectividadContra: nombreTipo
	(Tipo existeTipo: nombreTipo)
		ifFalse: [ Error signal: 'El tipo no existe' ].
	^ efectividades at: nombreTipo ifAbsent: 1! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:20'!
hash
	^nombre hash! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:53'!
initializeOnNombre: nombreTipo 

	nombre := nombreTipo.
	efectividades := Dictionary new.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:46'!
nombre
	^nombre.! !

TestCase subclass: #PokemonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:34'!
basicFuego

	^Tipo new: 'fuego'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:53'!
createABellossom 

	^self createBellossom new: 'Gloom'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 02:49'!
createANinetalesNamedExvulpix 

	^self createNinetales new: 'Exvulpix'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:26'!
createAStoutland

	^self createStoutland new: 'Stout'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 14:00'!
createAWailord

	^self createWailord  new: 'Whale'.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:28'!
createBellossom
	^ Pokemon
		nuevaEspecie: 'Bellossom'
		conTipo: 'planta'
		energiaBase: 75
		ataqueBase: 90
		defensaBase: 100! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:27'!
createMismagius
	^ Pokemon
		nuevaEspecie: 'Mismagius'
		conTipo: 'fantasma'
		energiaBase: 60
		ataqueBase: 105
		defensaBase: 105! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:27'!
createNinetales
	^ Pokemon
		nuevaEspecie: 'Ninetales'
		conTipo: 'fuego'
		energiaBase: 73
		ataqueBase: 81
		defensaBase: 100! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:27'!
createStoutland
	^ Pokemon
		nuevaEspecie: 'Stoutland'
		conTipo: 'normal'
		energiaBase: 85
		ataqueBase: 100
		defensaBase: 90! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:28'!
createWailord
	^ Pokemon
		nuevaEspecie: 'Wailord'
		conTipo: 'agua'
		energiaBase: 170
		ataqueBase: 90
		defensaBase: 45! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:25'!
levelUp: aPokemon to: anInteger
	| aBellossom |
	aBellossom := self createABellossom.
	anInteger - aPokemon nivel
		timesRepeat: [ 
			aPokemon atacarA: aBellossom conPoder: 120 deTipo: (Tipo new: 'fuego').
			aBellossom curar: 1 ].
	^aPokemon! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:58'!
test01TypeShouldBeCreatedWithNameAndEfectiveness1
	|fuego|
	
	fuego:= self basicFuego.

	self assert: (fuego nombre = 'fuego').
	self assert: ((fuego efectividadContra: 'fuego') = 1 )! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:43'!
test02TypeCanBeAskedForExistence
	|fuego|
	
	fuego:= self basicFuego.

	self assert: (Tipo existeTipo: 'fuego').
	self deny: (Tipo existeTipo: 'notType').! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:41'!
test03TypeCanRedefineEfectiveness
	|fuego|
	
	fuego:= self basicFuego.

	fuego efectividad: 1/2 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = (1/2)).
	fuego efectividad: 1 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1)! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:55'!
test04TypeCantRedefineEfectivenessOnNotAnEffectivenessValueOrAgainstNonexistantType
	|fuego|
	
	fuego:= self basicFuego.

	fuego efectividad: 3 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).
	fuego efectividad: -1 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).
	fuego efectividad: 3/4 contra: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') = 1).
	fuego efectividad: 3/4 contra: 'notType'.
	self should:    [  ((fuego efectividadContra: 'notType') = 1)] raise: Error withExceptionDo:[:error | self assert: error messageText =  'El tipo no existe' ]! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:49'!
test05LoadInitialTypesLoadsCorrectValues
	|fuego agua fantasma planta normal|
	
	Tipo cargarTiposIniciales.
	
	self assert: (Tipo existeTipo: 'fuego').
	fuego := Tipo getInstance: 'fuego'.
	self assert: ((fuego efectividadContra: 'fuego') =  0.5).
	self assert: ((fuego efectividadContra: 'agua') = 0.5).
	self assert: ((fuego efectividadContra: 'planta') = 2).
	self assert: ((fuego efectividadContra: 'normal') = 1).
	self assert: ((fuego efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'agua').
	agua := Tipo getInstance: 'agua'.
	self assert: ((agua efectividadContra: 'fuego') =  2).
	self assert: ((agua efectividadContra: 'agua') = 0.5).
	self assert: ((agua efectividadContra: 'planta') = 0.5).
	self assert: ((agua efectividadContra: 'normal') = 1).
	self assert: ((agua efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'planta').
	planta := Tipo getInstance: 'planta'.
	self assert: ((planta efectividadContra: 'fuego') =  0.5).
	self assert: ((planta efectividadContra: 'agua') = 2).
	self assert: ((planta efectividadContra: 'planta') = 0.5).
	self assert: ((planta efectividadContra: 'normal') = 1).
	self assert: ((planta efectividadContra: 'fantasma') = 1).
	
	self assert: (Tipo existeTipo: 'normal').
	normal := Tipo getInstance: 'normal'.
	self assert: ((normal efectividadContra: 'fuego') =  1).
	self assert: ((normal efectividadContra: 'agua') = 1).
	self assert: ((normal efectividadContra: 'planta') = 1).
	self assert: ((normal efectividadContra: 'normal') = 1).
	self assert: ((normal efectividadContra: 'fantasma') = 0).
	
	self assert: (Tipo existeTipo: 'fantasma').
	fantasma := Tipo getInstance: 'fantasma'.
	self assert: ((fantasma efectividadContra: 'fuego') =  1).
	self assert: ((fantasma efectividadContra: 'agua') = 1).
	self assert: ((fantasma efectividadContra: 'planta') = 1).
	self assert: ((fantasma efectividadContra: 'normal') = 0).
	self assert: ((fantasma efectividadContra: 'fantasma') = 2).! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 02:38'!
test06PokemonClassDoesNotImplementSubclassSpecificMethods
	
	self should: [Pokemon ataqueBase] raise: SubclassResponsibility.
	self should: [Pokemon defensaBase ] raise: SubclassResponsibility.
	self should: [Pokemon energiaBase ] raise: SubclassResponsibility.
	self should: [Pokemon tipo] raise: SubclassResponsibility.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 02:45'!
test07CanCreateNewSpeciesOfPokemon
	| ninetales |
	Tipo cargarTiposIniciales.
	ninetales := self createNinetales.
	self assert: ninetales energiaBase = 73.
	self assert: ninetales ataqueBase = 81.
	self assert: ninetales defensaBase = 100.
	self assert: ninetales tipo nombre = 'fuego'.
	self assert: ((ninetales tipo efectividadContra: 'agua') = (1 / 2))! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 02:51'!
test08CanCreateNewBaby
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	self assert: aNinetales nombre = 'Exvulpix'.
	self assert: aNinetales nivel = 1.
	self assert: aNinetales energia  = aNinetales energiaTotal.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 02:58'!
test09ParametersAreCalculatedCorrectly
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	self assert: aNinetales energiaTotal  = 13.
	self assert: aNinetales ataque = 8.
	self assert: aNinetales defensa  = 8.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 03:02'!
test10HurtRemovesCorrectEnergy
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	aNinetales herir: 10.
	
	self assert: aNinetales energia = 3.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 03:02'!
test11HurtDoesNotMakeEnergyGoBelowZero
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	aNinetales herir: 15.
	
	self assert: aNinetales energia = 0.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 03:01'!
test12HealAddsCorrectEnergy
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	aNinetales herir: 6.
	aNinetales curar: 3.
	self assert: aNinetales energia = 10.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 03:01'!
test13HealDoesNotMakeEnergyGoOverTotalEnergy
	| aNinetales |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	
	aNinetales herir: 6.
	aNinetales curar: 10.
	self assert: aNinetales energia = 13.
	
	
	! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 13:29'!
test14AttackingAPokemonDoesCorrectDamageWithNoWeaknessOrResistanceWithSTAB
	| aNinetales aStoutland |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aStoutland := self createAStoutland.
	aNinetales atacarA: aStoutland conPoder: 10 deTipo: (Tipo new: 'fuego').
	self assert: aStoutland energia = 10! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 14:17'!
test15AttackingAPokemonDoesCorrectDamageWithNoWeaknessOrResistanceWithoutSTAB
	| aNinetales aStoutland |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aStoutland := self createAStoutland.
	aNinetales atacarA: aStoutland conPoder: 10 deTipo: (Tipo new: 'planta').
	self assert: aStoutland energia = 12! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 14:28'!
test16AttackingAPokemonDoesCorrectDamageWithWeakness
	| aNinetales aBellossom |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aBellossom := self createABellossom.
	aNinetales atacarA: aBellossom conPoder: 10 deTipo: (Tipo new: 'fuego').
	self assert: aBellossom energia = 6! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/16/2012 14:29'!
test17AttackingAPokemonDoesCorrectDamageWithResistance
	| aNinetales aWailord |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aWailord := self createAWailord.
	aNinetales atacarA: aWailord conPoder: 10 deTipo: (Tipo new: 'fuego').
	self assert: aWailord energia = 13.! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/21/2012 11:41'!
test18AttackingAPokemonDoesNoDamageWithZeroEffectiveness
	| aNinetales aStoutland |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aStoutland := self createAStoutland..
	aNinetales atacarA: aStoutland conPoder: 10 deTipo: (Tipo new: 'fantasma').
	self assert: aStoutland energia = 14! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/21/2012 11:41'!
test19BeatingAPokemonLevelsUp
	| aNinetales aBellossom prevLevel |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aBellossom := self createABellossom.
	prevLevel := aNinetales nivel. aNinetales atacarA: aBellossom conPoder: 50 deTipo: (Tipo new: 'fuego').
	self assert: aBellossom energia = 0.
	self assert: aNinetales nivel = (prevLevel + 1)! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:20'!
test20BeatingAPokemonDoesNotLevelUpIfPokemonIsLevel100
	| aNinetales aBellossom prevLevel |
	Tipo cargarTiposIniciales.
	aNinetales := self levelUp: (self createANinetalesNamedExvulpix) to: 100.
	aBellossom := self createABellossom.
	aNinetales atacarA: aBellossom conPoder: 10 deTipo: (Tipo new: 'fuego').
	self assert: aBellossom energia = 0.
	self assert: aNinetales nivel = 100! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:56'!
test21CantAttackIfPokemonHasFainted
	| aNinetales aBellossom prevLevel |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aBellossom := self createABellossom.
	aNinetales atacarA: aBellossom conPoder: 120 deTipo: (Tipo new: 'fuego').
	self
		should: [aBellossom atacarA: aNinetales conPoder: 10 deTipo: (Tipo new: 'fuego')]
		raise: Error
		withExceptionDo: [ :error | self assert:  error messageText = 'Pokemon has fainted, it cannot attack until it is cured' ]! !

!PokemonTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 7/6/2012 00:55'!
test22CantAttackFaintedPokemon
	| aNinetales aBellossom prevLevel |
	Tipo cargarTiposIniciales.
	aNinetales := self createANinetalesNamedExvulpix.
	aBellossom := self createABellossom.
	aNinetales atacarA: aBellossom conPoder: 120 deTipo: (Tipo new: 'fuego').
	self
		should: [aNinetales atacarA: aBellossom conPoder: 10 deTipo: (Tipo new: 'fuego')]
		raise: Error
		withExceptionDo: [ :error | self assert: error messageText =  'Opponent has fainted, it cannot be attacked until it is cured']! !
